//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Authentication
{
    
    
    /// <summary>
    /// Response type for the Login command
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute("Login - Response")]
    public struct LoginResponse
    {
        
        private string _accessToken;
        
        private long _tokenLifetime;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public LoginResponse(string accessToken, long tokenLifetime)
        {
            _accessToken = accessToken;
            _tokenLifetime = tokenLifetime;
        }
        
        /// <summary>
        /// The token to be used along with accessing a Command or Property on a SiLA Server.
        /// </summary>
        public string AccessToken
        {
            get
            {
                return _accessToken;
            }
        }
        
        /// <summary>
        /// The lifetime (in seconds) of the provided access token as the maximum validity period after the last SiLA Server
        /// request.
        /// </summary>
        [Tecan.Sila2.UnitAttribute("s", Second=1)]
        public long TokenLifetime
        {
            get
            {
                return _tokenLifetime;
            }
        }
    }
    
    /// <summary>
    /// This Feature provides SiLA Clients with access tokens based on a user identification and password.
    /// 1. the user needs to login with the Login command into the server with a user identification (=user name) and a password
    /// 2. after verification, an Access Token with the Token Lifetime information will be generated and provided by the server.
    /// 3. the user can log-out from the server with the Logout command - a valid Access Token is required to run this command.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "core")]
    [Tecan.Sila2.SilaIdentifierAttribute("AuthenticationService")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Authentication Service")]
    public partial interface IAuthenticationService
    {
        
        /// <summary>
        /// Provides an access token based on user information.
        /// </summary>
        /// <param name="userIdentification">The user identification string (e.g. a user name)</param>
        /// <param name="password">The (encrypted) password</param>
        /// <param name="requestedServer">The ServerUUID of the server for which an authorization is requested.</param>
        /// <param name="requestedFeatures">The fully qualified identifiers of features that are requested to access. If no feature is provided, this means that all features are requested.</param>
        /// <returns>
        /// The token to be used along with accessing a Command or Property on a SiLA Server.,
        /// The lifetime (in seconds) of the provided access token as the maximum validity period after the last SiLA Server
        /// request.
        /// </returns>
        [Tecan.Sila2.ThrowsAttribute(typeof(AuthenticationFailedException))]
        [return: Tecan.Sila2.InlineStructAttribute()]
        LoginResponse Login(string userIdentification, string password, [Tecan.Sila2.PatternConstraintAttribute("[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}")] string requestedServer, [Tecan.Sila2.SilaIdentifierTypeAttribute(Tecan.Sila2.IdentifierType.FeatureIdentifier)] System.Collections.Generic.ICollection<string> requestedFeatures);
        
        /// <summary>
        /// Invalidates the given access token immediately.
        /// </summary>
        /// <param name="accessToken">The access token to be invalidated.</param>
        [Tecan.Sila2.ThrowsAttribute(typeof(InvalidAccessTokenException))]
        void Logout(string accessToken);
    }
    
    /// <summary>
    /// The provided credentials are not valid.
    /// </summary>
    public class AuthenticationFailedException : System.Exception
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="message">The actual error message</param>
        public AuthenticationFailedException(string message) : 
                base(message)
        {
        }
    }
    
    /// <summary>
    /// The sent access token is not valid.
    /// </summary>
    public class InvalidAccessTokenException : System.Exception
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="message">The actual error message</param>
        public InvalidAccessTokenException(string message) : 
                base(message)
        {
        }
    }
}
